Index: /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 2385)
+++ /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 2386)
@@ -42,6 +42,7 @@
 	pj_lock_release(ioqueue->lock);
         return pj_lock_destroy(ioqueue->lock);
-    } else
-        return PJ_SUCCESS;
+    }
+    
+    return PJ_SUCCESS;
 }
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/transport.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/transport.h	(revision 2385)
+++ /pjproject/trunk/pjmedia/include/pjmedia/transport.h	(revision 2386)
@@ -542,6 +542,6 @@
     if (tp && tp->op && tp->op->get_info)
 	return (*tp->op->get_info)(tp, info);
-    else
-	return PJ_ENOTSUP;
+    
+    return PJ_ENOTSUP;
 }
 
Index: /pjproject/trunk/pjnath/include/pjnath/stun_session.h
===================================================================
--- /pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 2385)
+++ /pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 2386)
@@ -232,5 +232,5 @@
     void		*pkt;		/**< The STUN packet.		    */
     unsigned		 max_len;	/**< Length of packet buffer.	    */
-    unsigned		 pkt_size;	/**< The actual length of STUN pkt. */
+    pj_size_t		 pkt_size;	/**< The actual length of STUN pkt. */
 
     unsigned		 addr_len;	/**< Length of destination address. */
@@ -599,5 +599,5 @@
 					       unsigned options,
 					       void *token,
-					       unsigned *parsed_len,
+					       pj_size_t *parsed_len,
 					       const pj_sockaddr_t *src_addr,
 					       unsigned src_addr_len);
Index: /pjproject/trunk/pjnath/include/pjnath/turn_session.h
===================================================================
--- /pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 2385)
+++ /pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 2386)
@@ -593,6 +593,6 @@
 PJ_DECL(pj_status_t) pj_turn_session_on_rx_pkt(pj_turn_session *sess,
 					       void *pkt,
-					       unsigned pkt_len,
-					       unsigned *parsed_len);
+					       pj_size_t pkt_len,
+					       pj_size_t *parsed_len);
 
 
Index: /pjproject/trunk/pjnath/src/pjnath-test/stun.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath-test/stun.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjnath-test/stun.c	(revision 2386)
@@ -243,5 +243,5 @@
 	pj_uint8_t buf[1500];
 	pj_str_t key;
-	unsigned len;
+	pj_size_t len;
 	pj_status_t status;
 
@@ -544,6 +544,7 @@
 	struct test_vector *v;
 	pj_stun_msg *ref_msg, *msg;
-	unsigned parsed_len;
-	unsigned len, pos;
+	pj_size_t parsed_len;
+	pj_size_t len;
+	unsigned pos;
 	pj_uint8_t buf[1500];
 	char print[1500];
@@ -747,5 +748,5 @@
     pj_uint8_t packet[500];
     pj_stun_auth_cred cred;
-    unsigned len;
+    pj_size_t len;
     pj_status_t rc;
 
Index: /pjproject/trunk/pjnath/src/pjnath/stun_session.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 2386)
@@ -1055,5 +1055,5 @@
 {
     pj_uint8_t *out_pkt;
-    unsigned out_max_len, out_len;
+    pj_size_t out_max_len, out_len;
     pj_status_t status;
 
@@ -1320,5 +1320,5 @@
 					      unsigned options,
 					      void *token,
-					      unsigned *parsed_len,
+					      pj_size_t *parsed_len,
 					      const pj_sockaddr_t *src_addr,
 					      unsigned src_addr_len)
Index: /pjproject/trunk/pjnath/src/pjnath/turn_session.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/turn_session.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjnath/turn_session.c	(revision 2386)
@@ -915,6 +915,6 @@
 PJ_DEF(pj_status_t) pj_turn_session_on_rx_pkt(pj_turn_session *sess,
 					      void *pkt,
-					      unsigned pkt_len,
-					      unsigned *parsed_len)
+					      pj_size_t pkt_len,
+					      pj_size_t *parsed_len)
 {
     pj_bool_t is_stun;
Index: /pjproject/trunk/pjnath/src/pjnath/turn_sock.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 2386)
@@ -464,5 +464,5 @@
 {
     pj_turn_sock *turn_sock;
-    unsigned parsed_len;
+    pj_size_t parsed_len;
     pj_bool_t ret = PJ_TRUE;
 
Index: /pjproject/trunk/pjnath/src/pjturn-srv/allocation.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjturn-srv/allocation.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjturn-srv/allocation.c	(revision 2386)
@@ -935,5 +935,5 @@
 	 */
 	unsigned options = PJ_STUN_CHECK_PACKET | PJ_STUN_NO_FINGERPRINT_CHECK;
-	unsigned parsed_len = 0;
+	pj_size_t parsed_len = 0;
 
 	if (pkt->transport->listener->tp_type == PJ_TURN_TP_UDP)
Index: /pjproject/trunk/pjnath/src/pjturn-srv/main.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjturn-srv/main.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjturn-srv/main.c	(revision 2386)
@@ -50,6 +50,6 @@
 
     printf("Worker threads : %d\n", srv->core.thread_cnt);
-    printf("Total mem usage: %d.%03dMB\n", g_cp.used_size / 1000000, 
-	   (g_cp.used_size % 1000000)/1000);
+    printf("Total mem usage: %u.%03uMB\n", (unsigned)(g_cp.used_size / 1000000), 
+	   (unsigned)((g_cp.used_size % 1000000)/1000));
     printf("UDP port range : %u %u %u (next/min/max)\n", srv->ports.next_udp,
 	   srv->ports.min_udp, srv->ports.max_udp);
Index: /pjproject/trunk/pjnath/src/pjturn-srv/server.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjturn-srv/server.c	(revision 2385)
+++ /pjproject/trunk/pjnath/src/pjturn-srv/server.c	(revision 2386)
@@ -616,5 +616,5 @@
 	/* Otherwise this is a new client */
 	unsigned options;
-	unsigned parsed_len;
+	pj_size_t parsed_len;
 	pj_status_t status;
 
Index: /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 2385)
+++ /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 2386)
@@ -688,5 +688,5 @@
     enum { COUNT = 2000 };
     unsigned i;
-    pj_status_t status;
+    pj_status_t status = PJ_SUCCESS;
 
     /* exhaust packets */