Index: pjproject/trunk/tests/cdash/builder.py
===================================================================
--- pjproject/trunk/tests/cdash/builder.py	(revision 2400)
+++ pjproject/trunk/tests/cdash/builder.py	(revision 2401)
@@ -1,2 +1,22 @@
+#
+# builder.py - PJSIP test scenarios builder
+#
+# Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
 import ccdash
 import os
@@ -194,10 +214,10 @@
             included = False
             for pat in self.exclude:
-                if re.search(pat, fullcmd) != None:
+                if pat and re.search(pat, fullcmd) != None:
                     excluded = True
                     break
             if excluded:
                 for pat in self.not_exclude:
-                    if re.search(pat, fullcmd) != None:
+                    if pat and re.search(pat, fullcmd) != None:
                         included = True
                         break
Index: pjproject/trunk/tests/cdash/cfg_gnu.py
===================================================================
--- pjproject/trunk/tests/cdash/cfg_gnu.py	(revision 2400)
+++ pjproject/trunk/tests/cdash/cfg_gnu.py	(revision 2401)
@@ -1,2 +1,21 @@
+#
+# cfg_gnu.py - GNU target configurator
+#
+# Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
 import builder
 import os
@@ -14,6 +33,6 @@
 
     if os.access(file+".py", os.F_OK) == False:
-	print "Error: file '%s.py' doesn't exist." % (file)
-	sys.exit(1)
+        print "Error: file '%s.py' doesn't exist." % (file)
+        sys.exit(1)
 
     cfg_site = __import__(file)
Index: pjproject/trunk/tests/cdash/cfg_site_sample.py
===================================================================
--- pjproject/trunk/tests/cdash/cfg_site_sample.py	(revision 2400)
+++ pjproject/trunk/tests/cdash/cfg_site_sample.py	(revision 2401)
@@ -1,2 +1,21 @@
+#
+# cfg_site_sample.py - Sample site configuration
+#
+# Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
 import builder
 
Index: pjproject/trunk/tests/cdash/main.py
===================================================================
--- pjproject/trunk/tests/cdash/main.py	(revision 2400)
+++ pjproject/trunk/tests/cdash/main.py	(revision 2401)
@@ -1,2 +1,24 @@
+#!/bin/env python
+
+#
+# main.py - main entry for PJSIP's CDash tests
+#
+# Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
 import sys
 