Index: pjproject/trunk/pjmedia/build/pjmedia_test.vcproj
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia_test.vcproj	(revision 2401)
+++ pjproject/trunk/pjmedia/build/pjmedia_test.vcproj	(revision 2402)
@@ -72,5 +72,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib odbc32.lib odbccp32.lib  ole32.lib user32.lib"
-				OutputFile="../bin/pjmedia_test_vc8d.exe"
+				OutputFile="../bin/pjmedia-test-i386-win32-vc8-release.exe"
 				LinkIncremental="2"
 				SuppressStartupBanner="true"
@@ -165,5 +165,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib odbc32.lib odbccp32.lib ole32.lib user32.lib"
-				OutputFile="../bin/pjmedia_test_vc8.exe"
+				OutputFile="../bin/pjmedia-test-i386-win32-vc8-release.exe"
 				LinkIncremental="1"
 				SuppressStartupBanner="true"
Index: pjproject/trunk/pjnath/build/pjnath_test.vcproj
===================================================================
--- pjproject/trunk/pjnath/build/pjnath_test.vcproj	(revision 2401)
+++ pjproject/trunk/pjnath/build/pjnath_test.vcproj	(revision 2402)
@@ -253,4 +253,12 @@
 			</File>
 			<File
+				RelativePath="..\src\pjnath-test\server.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjnath-test\sess_auth.c"
+				>
+			</File>
+			<File
 				RelativePath="..\src\pjnath-test\stun.c"
 				>
@@ -275,4 +283,8 @@
 			</File>
 			<File
+				RelativePath="..\src\pjnath-test\stun_sock_test.c"
+				>
+			</File>
+			<File
 				RelativePath="..\src\pjnath-test\test.c"
 				>
@@ -295,4 +307,8 @@
 					/>
 				</FileConfiguration>
+			</File>
+			<File
+				RelativePath="..\src\pjnath-test\turn_sock_test.c"
+				>
 			</File>
 		</Filter>
Index: pjproject/trunk/pjproject-vs8.sln
===================================================================
--- pjproject/trunk/pjproject-vs8.sln	(revision 2401)
+++ pjproject/trunk/pjproject-vs8.sln	(revision 2402)
@@ -1,5 +1,5 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 9.00
-# Visual C++ Express 2005
+# Visual Studio 2005
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib", "pjlib\build\pjlib.vcproj", "{DA0E03ED-53A7-4050-8A85-90541C5509F8}"
 EndProject
@@ -117,4 +117,26 @@
 EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libsrtp", "third_party\build\srtp\libsrtp.vcproj", "{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjnath_test", "pjnath\build\pjnath_test.vcproj", "{553C094C-F581-4A80-9540-D5D7B398A2C6}"
+	ProjectSection(ProjectDependencies) = postProject
+		{DA0E03ED-53A7-4050-8A85-90541C5509F8} = {DA0E03ED-53A7-4050-8A85-90541C5509F8}
+		{FE07F272-AE7F-4549-9E9F-EF9B80CB1693} = {FE07F272-AE7F-4549-9E9F-EF9B80CB1693}
+		{A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4} = {A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjmedia_test", "pjmedia\build\pjmedia_test.vcproj", "{21C0CECF-69DD-4F70-BC2B-9B4DE7F15277}"
+	ProjectSection(ProjectDependencies) = postProject
+		{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858} = {F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D} = {4BF51C21-5A30-423B-82FE-1ED410E5769D}
+		{FE07F272-AE7F-4549-9E9F-EF9B80CB1693} = {FE07F272-AE7F-4549-9E9F-EF9B80CB1693}
+		{6794B975-4E84-4F49-B2DC-C31F2224E03E} = {6794B975-4E84-4F49-B2DC-C31F2224E03E}
+		{7FDE3880-A4AB-49E3-B439-EBEF0A0C7A65} = {7FDE3880-A4AB-49E3-B439-EBEF0A0C7A65}
+		{3CF9FFA9-8387-4635-9D1B-E7944CBEFEAA} = {3CF9FFA9-8387-4635-9D1B-E7944CBEFEAA}
+		{4B059DBA-CD9C-4D0F-BE8C-FFB4EFD498E9} = {4B059DBA-CD9C-4D0F-BE8C-FFB4EFD498E9}
+		{855DC8C0-D3E9-4A2E-AE47-116605A7BC9B} = {855DC8C0-D3E9-4A2E-AE47-116605A7BC9B}
+		{DA0E03ED-53A7-4050-8A85-90541C5509F8} = {DA0E03ED-53A7-4050-8A85-90541C5509F8}
+		{B5FE16F8-3EDB-4110-BD80-B4238CC01E8D} = {B5FE16F8-3EDB-4110-BD80-B4238CC01E8D}
+		{E53AA5FF-B737-40AA-BD13-387EFA99023D} = {E53AA5FF-B737-40AA-BD13-387EFA99023D}
+	EndProjectSection
 EndProject
 Global
@@ -216,4 +238,12 @@
 		{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}.Release|Win32.ActiveCfg = Release|Win32
 		{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}.Release|Win32.Build.0 = Release|Win32
+		{553C094C-F581-4A80-9540-D5D7B398A2C6}.Debug|Win32.ActiveCfg = Debug|Win32
+		{553C094C-F581-4A80-9540-D5D7B398A2C6}.Debug|Win32.Build.0 = Debug|Win32
+		{553C094C-F581-4A80-9540-D5D7B398A2C6}.Release|Win32.ActiveCfg = Release|Win32
+		{553C094C-F581-4A80-9540-D5D7B398A2C6}.Release|Win32.Build.0 = Release|Win32
+		{21C0CECF-69DD-4F70-BC2B-9B4DE7F15277}.Debug|Win32.ActiveCfg = Debug|Win32
+		{21C0CECF-69DD-4F70-BC2B-9B4DE7F15277}.Debug|Win32.Build.0 = Debug|Win32
+		{21C0CECF-69DD-4F70-BC2B-9B4DE7F15277}.Release|Win32.ActiveCfg = Release|Win32
+		{21C0CECF-69DD-4F70-BC2B-9B4DE7F15277}.Release|Win32.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: pjproject/trunk/pjsip/build/test_pjsip.vcproj
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.vcproj	(revision 2401)
+++ pjproject/trunk/pjsip/build/test_pjsip.vcproj	(revision 2402)
@@ -74,5 +74,5 @@
 				AdditionalOptions="/FIXED:NO"
 				AdditionalDependencies="dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib odbc32.lib odbccp32.lib ole32.lib"
-				OutputFile="..\bin\test-pjsip-i386-win32-vc8-release.exe"
+				OutputFile="..\bin\pjsip-test-i386-win32-vc8-release.exe"
 				LinkIncremental="1"
 				SuppressStartupBanner="true"
@@ -168,5 +168,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib odbc32.lib odbccp32.lib ole32.lib"
-				OutputFile="..\bin\test-pjsip-i386-win32-vc8-debug.exe"
+				OutputFile="..\bin\pjsip-test-i386-win32-vc8-debug.exe"
 				LinkIncremental="2"
 				SuppressStartupBanner="true"